import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.Toolkit;

import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;

import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetAdapter;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import java.util.List;

import javax.swing.ImageIcon;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;

import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.MenuEvent;
import javax.swing.event.MenuListener;
import javax.swing.event.UndoableEditEvent;
import javax.swing.event.UndoableEditListener;

import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import javax.swing.undo.UndoManager;

public class JPad extends JFrame
{
   private final static String DEFAULT_TITLE = "Untitled - JPad";
   private final static String DEFAULT_STATUS = "JPad 1.0";
   private final static String SAVE_CHNGS = "Save changes?";
   private final static String TITLE_AYS = "Are You Sure?";
   private Clipboard cb;
   private JFileChooser fc;
   private boolean fDirty;
   private JTextArea ta;
   private ImageIcon icon;
   private UndoManager um;
   private DropTarget dt;
   private JLabel lbl;
   private File fileCurrent;

   public JPad(String[] args)
   {
      cb = Toolkit.getDefaultToolkit().getSystemClipboard();
      fc = new JFileChooser(".");
      fc.setAcceptAllFileFilterUsed(false);
      FileFilter ff = new FileNameExtensionFilter("TXT documents (*.txt)",
                                                  "*.txt");
      fc.addChoosableFileFilter(ff);
      ff = new FileNameExtensionFilter("All Files", "*.*");
      fc.addChoosableFileFilter(ff);
      JMenuBar mb = new JMenuBar();
      JMenu mFile = new JMenu("File");
      JMenuItem miNew = new JMenuItem("New");
      miNew.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,
                                                  KeyEvent.CTRL_MASK));
      ActionListener al;
      al = new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent ae)
         {
            if (fDirty)
               switch (JOptionPane.showConfirmDialog(JPad.this, SAVE_CHNGS,
                                                     TITLE_AYS,
                                                     JOptionPane.YES_NO_OPTION))
               {
                  case JOptionPane.YES_OPTION: if (doSave()) doNew(); break;
                  case JOptionPane.NO_OPTION : doNew();
               }
            else
               doNew();
         }
      };
      miNew.addActionListener(al);
      mFile.add(miNew);
      JMenuItem miOpen = new JMenuItem("Open...");
      miOpen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,
                                                   KeyEvent.CTRL_MASK));
      al = new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent ae)
         {
            if (fDirty)
               switch (JOptionPane.showConfirmDialog(JPad.this, SAVE_CHNGS,
                                                     TITLE_AYS,
                                                     JOptionPane.YES_NO_OPTION))
               {
                  case JOptionPane.YES_OPTION: if (doSave()) doOpen(); break;
                  case JOptionPane.NO_OPTION : doOpen();
               }
            else
               doOpen();
         }
      };
      miOpen.addActionListener(al);
      mFile.add(miOpen);
      JMenuItem miSave = new JMenuItem("Save");
      miSave.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
                                                   KeyEvent.CTRL_MASK));
      al = new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent ae)
         {
            doSave();
         }
      };
      miSave.addActionListener(al);
      mFile.add(miSave);
      JMenuItem miSaveAs = new JMenuItem("Save As...");
      al = new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent ae)
         {
            doSaveAs();
         }
      };
      miSaveAs.addActionListener(al);
      mFile.add(miSaveAs);
      mFile.addSeparator();
      JMenuItem miExit = new JMenuItem("Exit");
      al = new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent ae)
         {
            doExit();
         }
      };
      miExit.addActionListener(al);
      mFile.add(miExit);
      MenuListener ml;
      ml = new MenuListener()
      {
         @Override
         public void menuCanceled(MenuEvent me)
         {
         }
         @Override
         public void menuDeselected(MenuEvent me)
         {
            lbl.setText(DEFAULT_STATUS);
         }
         @Override
         public void menuSelected(MenuEvent me)
         {
            lbl.setText("New doc|Open existing doc|Save changes|Exit");
         }
      };
      mFile.addMenuListener(ml);
      mb.add(mFile);
      JMenu mEdit = new JMenu("Edit");
      final JMenuItem miUndo = new JMenuItem("Undo");
      miUndo.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,
                                                   KeyEvent.CTRL_MASK));
      al = new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent ae)
         {
            um.undo();
         }
      };
      miUndo.addActionListener(al);
      mEdit.add(miUndo);
      mEdit.addSeparator();
      final JMenuItem miCut = new JMenuItem("Cut");
      miCut.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,
                                                  KeyEvent.CTRL_MASK));
      miCut.setEnabled(false);
      al = new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent ae)
         {
            ta.cut();
         }
      };
      miCut.addActionListener(al);
      mEdit.add(miCut);
      final JMenuItem miCopy = new JMenuItem("Copy");
      miCopy.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,
                                                   KeyEvent.CTRL_MASK));
      miCopy.setEnabled(false);
      al = new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent ae)
         {
            ta.copy();
         }
      };
      miCopy.addActionListener(al);
      mEdit.add(miCopy);
      final JMenuItem miPaste = new JMenuItem("Paste");
      miPaste.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V,
                                                    KeyEvent.CTRL_MASK));
      al = new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent ae)
         {
            ta.paste();
         }
      };
      miPaste.addActionListener(al);
      mEdit.add(miPaste);
      mEdit.addSeparator();
      JMenuItem miSelectAll = new JMenuItem("Select All");
      miSelectAll.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A,
                                                        KeyEvent.CTRL_MASK));
      al = new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent ae)
         {
            ta.selectAll();
         }
      };
      miSelectAll.addActionListener(al);
      mEdit.add(miSelectAll);
      ml = new MenuListener()
      {
         @Override
         public void menuCanceled(MenuEvent me)
         {
         }
         @Override
         public void menuDeselected(MenuEvent me)
         {
            lbl.setText(DEFAULT_STATUS);
         }
         @Override
         public void menuSelected(MenuEvent me)
         {
            miUndo.setEnabled(um.canUndo());
            boolean b = cb.isDataFlavorAvailable(DataFlavor.stringFlavor);
            miPaste.setEnabled(b);
            lbl.setText("Undo last change|Cut or copy selected text|Paste|"+
                        "Select all text");
         }
      };
      mEdit.addMenuListener(ml);
      mb.add(mEdit);
      JMenu mFormat = new JMenu("Format");
      final JCheckBoxMenuItem cbmiWordWrap = new JCheckBoxMenuItem("Word Wrap");
      al = new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent ae)
         {
            ta.setLineWrap(cbmiWordWrap.isSelected());
         }
      };
      cbmiWordWrap.addActionListener(al);
      mFormat.add(cbmiWordWrap);
      ml = new MenuListener()
      {
         @Override
         public void menuCanceled(MenuEvent me)
         {
         }
         @Override
         public void menuDeselected(MenuEvent me)
         {
            lbl.setText(DEFAULT_STATUS);
         }
         @Override
         public void menuSelected(MenuEvent me)
         {
            lbl.setText("Enable/disable word wrap");
         }
      };
      mFormat.addMenuListener(ml);
      mb.add(mFormat);
      JMenu mHelp = new JMenu("Help");
      final JMenuItem miAbout = new JMenuItem("About JPad");
      icon = new ImageIcon(getClass().getResource("icon.png"));
      al = new ActionListener()
      {
         @Override
         public void actionPerformed(ActionEvent ae)
         {
            JOptionPane.showMessageDialog(JPad.this,
                                          "JPad 1.0\nby Jeff Friesen\n",
                                          "JPad",
                                          JOptionPane.PLAIN_MESSAGE,
                                          icon);
         }
      };
      miAbout.addActionListener(al);
      mHelp.add(miAbout);
      ml = new MenuListener()
      {
         @Override
         public void menuCanceled(MenuEvent me)
         {
         }
         @Override
         public void menuDeselected(MenuEvent me)
         {
            lbl.setText(DEFAULT_STATUS);
         }
         @Override
         public void menuSelected(MenuEvent me)
         {
            lbl.setText("View about information");
         }
      };
      mHelp.addMenuListener(ml);
      mb.add(mHelp);
      setJMenuBar(mb);
      getContentPane().add(new JScrollPane (ta = new JTextArea()));
      DocumentListener dl;
      dl = new DocumentListener()
      {
         @Override
         public void changedUpdate(DocumentEvent de)
         {
            // Not needed -- only called when attributes are changed
         }
         @Override
         public void insertUpdate(DocumentEvent de)
         {
            fDirty = true;
         }
         @Override
         public void removeUpdate(DocumentEvent de)
         {
            fDirty = true;
         }
      };
      ta.getDocument().addDocumentListener(dl);
      um = new UndoManager();
      UndoableEditListener uel;
      uel = new UndoableEditListener()
      {
         @Override
         public void undoableEditHappened(UndoableEditEvent uee)
         {
            um.addEdit(uee.getEdit());
         }
      };
      ta.getDocument().addUndoableEditListener(uel);
      CaretListener cl;
      cl = new CaretListener()
      {
         @Override
         public void caretUpdate(CaretEvent ce)
         {
            if (ta.getSelectedText() != null)
            {
               miCut.setEnabled(true);
               miCopy.setEnabled(true);
            }
            else
            {
               miCut.setEnabled(false);
               miCopy.setEnabled(false);
            }
         }
      };
      ta.addCaretListener(cl);
      DropTargetAdapter dta;
      dta = new DropTargetAdapter()
      {
         @Override
         public void dragOver(DropTargetDragEvent dtde)
         {
            Transferable tr = dtde.getTransferable();
            DataFlavor[] flavors = tr.getTransferDataFlavors();
            for (DataFlavor flavor: flavors)
               if (flavor.isFlavorJavaFileListType())
               {
                  dtde.acceptDrag(DnDConstants.ACTION_COPY);
                  return;
               }
         }
         @Override
         public void drop(DropTargetDropEvent dtde)
         {
            try
            {
               Transferable tr = dtde.getTransferable();
               DataFlavor[] flavors = tr.getTransferDataFlavors();
               for (DataFlavor flavor: flavors)
                  if (flavor.isFlavorJavaFileListType())
                  {
                     dtde.acceptDrop(DnDConstants.ACTION_COPY);
                     @SuppressWarnings("unchecked")
                     List<File> files = (List<File>) tr.getTransferData(flavor);
                     if (fDirty)
                        switch (JOptionPane.showConfirmDialog(JPad.this,
                                                              SAVE_CHNGS,
                                                              TITLE_AYS,
                                                              JOptionPane.YES_NO_OPTION))
                        {
                           case JOptionPane.YES_OPTION: if (doSave())
                                                           doOpen(files.get(0));
                                                        break;
                           case JOptionPane.NO_OPTION : doOpen(files.get(0));
                        }
                     else
                        doOpen(files.get(0));
                     dtde.dropComplete(true);
                     um.discardAllEdits();
                     return;
                  }
               dtde.rejectDrop();
            }
            catch (Exception e)
            {
               JOptionPane.showMessageDialog(JPad.this,
                                             "Drop error: "+e.getMessage(),
                                             "Alert",
                                             JOptionPane.ERROR_MESSAGE);
            }
         }
      };
      dt = new DropTarget(ta, dta);
      getContentPane().add(lbl = new JLabel("JPad 1.0"), BorderLayout.SOUTH);
      setSize(400, 400);
      setTitle(DEFAULT_TITLE);
      setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
      addWindowListener(new WindowAdapter()
      {
         @Override
         public void windowClosing(WindowEvent we)
         {
            doExit();
         }
      });
      setVisible(true);
      if (args.length != 0)
         doOpen(new File(args[0]));
   }
   private void doExit()
   {
      if (fDirty)
         switch (JOptionPane.showConfirmDialog(JPad.this, SAVE_CHNGS,
                                               TITLE_AYS,
                                               JOptionPane.YES_NO_OPTION))
         {
            case JOptionPane.YES_OPTION: if (doSave()) dispose(); break;
            case JOptionPane.NO_OPTION : dispose();
         }
      else
         dispose();
   }
   private void doNew()
   {
      fileCurrent = null;
      ta.setText("");
      setTitle(DEFAULT_TITLE);
      fDirty = false;
      um.discardAllEdits();
   }
   private void doOpen()
   {
      doOpen(null);
   }
   private void doOpen(File file)
   {
      try
      {
         if (file == null)
            if (fc.showOpenDialog(JPad.this) == JFileChooser.APPROVE_OPTION)
               file = fc.getSelectedFile();
         if (file == null)
            return;
         fc.setCurrentDirectory(file.getParentFile());
         if (file.toString().indexOf(".") == -1)
            file = new File(file+".txt");
         ta.setText(read(file));
         fileCurrent = file;
         ta.setCaretPosition(0);
         ta.requestFocus();
         setTitle(file.toString()+" - JPad");
         fDirty = false;
         um.discardAllEdits();
      }
      catch (IOException ioe)
      {
         JOptionPane.showMessageDialog(JPad.this,
                                       "I/O error: "+ioe.getMessage(),
                                       "Alert",
                                       JOptionPane.ERROR_MESSAGE);
      }
   }
   private boolean doSave()
   {
      if (fileCurrent == null)
         return doSaveAs();
      try
      {
         write(fileCurrent, ta.getText());
         fDirty = false;
         um.discardAllEdits();
         return true;
      }
      catch (IOException ioe)
      {
         JOptionPane.showMessageDialog(JPad.this,
                                       "I/O error: "+ioe.getMessage(),
                                       "Alert",
                                       JOptionPane.ERROR_MESSAGE);
         return false;
      }
   }
   private boolean doSaveAs()
   {
      try
      {
         File file = null;
         if (fc.showSaveDialog(JPad.this) == JFileChooser.APPROVE_OPTION)
            file = fc.getSelectedFile();
         else
            return false;
         fc.setCurrentDirectory(file.getParentFile());
         if (file.getName().indexOf(".") == -1)
            file = new File(file+".txt");
         write(file, ta.getText());
         fileCurrent = file;
         setTitle(file.toString()+" - JPad");
         fDirty = false;
         um.discardAllEdits();
         return true;
      }
      catch (IOException ioe)
      {
         JOptionPane.showMessageDialog(JPad.this,
                                       "I/O error: "+ioe.getMessage(),
                                       "Alert",
                                       JOptionPane.ERROR_MESSAGE);
         return false;
      }
   }
   private String read(File f) throws IOException
   {
      try (FileReader fr = new FileReader(f))
      {
         char[] buf = new char[(int) f.length()];
         fr.read(buf);
         return new String(buf);
      }
   }
   private void write(File f, String text) throws IOException
   {
      try (FileWriter fw = new FileWriter(f);
           PrintWriter pw = new PrintWriter(fw))
      {
         pw.print(text);
      }
   }
   public static void main(final String[] args)
   {
      Runnable r = new Runnable()
      {
         @Override
         public void run()
         {
            new JPad(args);
         }
      };
      EventQueue.invokeLater(r);
   }
}
